local YssDarkPact = LibStub("AceAddon-3.0"):NewAddon("YssDarkPact", "AceEvent-3.0", "LibSink-2.0")

local YDP_enable
local YDP_rank = 0
local YLT_enable
local YLT_rank = 0
local YLT_strength = 0
local YLT_multiplier = 0
local YLT_talent
local YDP_last_update = 0

local L_LTN = "Life Tap now!"
local L_DPN = "Dark Pact now!"
local l = GetLocale()

if l == "koKR" then
	L_LTN = "Life Tap now!" --needs translation
	L_DPN = "Dark Pact now!" --needs translation
elseif l == "frFR" then
	L_LTN = "Life Tap now!" --needs translation
	L_DPN = "Dark Pact now!" --needs translation
elseif l == "deDE" then
	L_LTN = "Life Tap now!" --needs translation
	L_DPN = "Dark Pact now!" --needs translation
elseif l == "zhCN" then
	L_LTN = "Life Tap now!" --needs translation
	L_DPN = "Dark Pact now!" --needs translation
elseif l == "zhTW" then
	L_LTN = "Life Tap now!" --needs translation
	L_DPN = "Dark Pact now!" --needs translation
elseif l == "ruRU" then
	L_LTN = "Life Tap now!" --needs translation
	L_DPN = "Dark Pact now!" --needs translation
end

function YssDarkPact:OnEnable()
	local _, Class = UnitClass("player")
	if Class == "WARLOCK" then
		YDP_DB = YDP_DB or {}
		
		local DPspellids = {
			["18220"] = 305,
			["18937"] = 440,
			["18938"] = 545,
			["27265"] = 700,
			["59092"] = 1200,
		}
		local LTspellSTR = {
			["1454"] = 10,
			["1455"] = 16,
			["1456"] = 34,
			["11687"] = 47,
			["11688"] = 52,
			["11689"] = 510,
			["27222"] = 720,
			["57946"] = 1490,
		}
		local LTspellMULT = {
			["1454"] = 1,
			["1455"] = 1.5,
			["1456"] = 2,
			["11687"] = 2.5,
			["11688"] = 3,
			["11689"] = 3,
			["27222"] = 3,
			["57946"] = 3,
		}
		local i = 1
		local _, _, offset, numSpells = GetSpellTabInfo(2);
		for s = offset + 1, offset + numSpells do
			local suid = tostring(string.match(GetSpellLink(GetSpellName(s, BOOKTYPE_SPELL)), "spell:(%d+)"))
			if DPspellids[suid] and (DPspellids[suid] > YDP_rank) then
				YDP_enable = true
				YDP_rank = DPspellids[suid]
			end
			if LTspellSTR[suid] and (tonumber(suid) > tonumber(YLT_rank)) then
				YLT_enable = true
				YLT_rank = suid
				YLT_strength = LTspellSTR[YLT_rank]
				YLT_multiplier = LTspellMULT[YLT_rank]
			end
		end
		local _, _, _, _, currentRank = GetTalentInfo(1, 6)
		YLT_talent = ((currentRank * 10) + 100) / 100
		if YLT_enable then
			self:RegisterEvent("UNIT_MANA")
		end
		YDP_DB = YDP_DB or {}
		self:SetSinkStorage(YDP_DB)
		self.sinkoptions = self:GetSinkAce3OptionsDataTable()
		LibStub("AceConfig-3.0"):RegisterOptionsTable('YssDarkPactBlizzOptions', self.sinkoptions)
	    self.optframe = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YssDarkPactBlizzOptions", "YssDarkPact")
	end
	YssDarkPact.OnEnable = nil
end

function YssDarkPact:UNIT_MANA(event, arg1)
	if arg1 == "pet" or arg1 == "player" then
		local YDP_stamp = GetTime()
		local SPI = UnitStat("player", 5)
		if YDP_stamp - YDP_last_update > 5 then
			--Spew('lt', YLT_strength + (SPI * YLT_multiplier))
			local SPI = UnitStat("player", 5)
			if not YDP_enable then
				if (UnitManaMax("player") - UnitMana("player") > (YLT_strength + (SPI * YLT_multiplier)) * YLT_talent) and (UnitHealth("player") > UnitHealthMax("player")-UnitHealth("player")) and (UnitHealth("player") > YLT_strength + (SPI * YLT_multiplier)) then
					self:Pour(L_LTN, 1, 0, 0, nil, 24, "OUTLINE", true)
					YDP_last_update = YDP_stamp
					return;
				end
			else
				if UnitManaMax("player") - UnitMana("player") > YDP_rank + (GetSpellBonusDamage(6) * .96) then
					if UnitMana("pet") >= YDP_rank + (GetSpellBonusDamage(6) * .96) then
						self:Pour(L_DPN, 1, 0, 0, nil, 24, "OUTLINE", true)
						YDP_last_update = YDP_stamp
						return;
					else
						if (UnitManaMax("player") - UnitMana("player") > (YLT_strength + (SPI * YLT_multiplier)) * YLT_talent) and (UnitHealth("player") > UnitHealthMax("player")-UnitHealth("player")) and (UnitHealth("player") > YLT_strength + (SPI * YLT_multiplier)) then
							self:Pour(L_LTN, 1, 0, 0, nil, 24, "OUTLINE", true)
							YDP_last_update = YDP_stamp
							return;
						end
					end
				end
			end
		end
	end
end
